<%/**
   * Module: P&E_v1.0
   * Copyright: Copyright (c) 2012
   * Company: Xerox Docushare
   * @version 1.0
**/ %>

<%@ page import="java.io.*,java.util.*"%>
<%@ page import="javax.servlet.http.HttpServletRequest,javax.servlet.http.HttpSession"%>
<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.amber.error.*" %>
<%@ page import="jp.co.fujixerox.docushare.amber.*" %>
<%@ page import="jp.co.fujixerox.docushare.amber.vdf.*" %>
<%@ page extends="com.xerox.docushare.amber.pages.common.SessionPage" %>
<%@ page import="com.xerox.docushare.printemail.impl.PrintEmailConfigImpl" %>
<%@ page import="com.xerox.docushare.printemail.impl.EmailActionImpl"%>
<%@ page import="com.xerox.docushare.printemail.impl.MobilePrintActionImpl" %>

<%!
// need to implement this abstract method from SessionPage.
protected boolean hasURLCheck()
{
   return false;
}

// need to implement this abstract method from SessionPage.
public void process(HttpServletRequest aRequest, HttpServletResponse aResponse)
   throws ServletException
{
   return;
}

protected boolean preprocess(HttpServletRequest aRequest, HttpServletResponse aResponse)
   throws ServletException, DSException, RedirectionException
{
   if (!super.preprocess(aRequest, aResponse)) {
      return false;
   }
   else {
      mDSSession = getDSSessionFromCookies();
      if(mDSSession == null)
         throw redirect(mLoginPage, new Exception(getMessage("InvalidSessionError")));

      DSLoginPrincipal principal = mDSSession.getLoginPrincipal();
      if (principal == null)
         throw redirect(mLoginPage, new Exception(getMessage("InvalidSessionError")));

      return true;
   }
}

protected void outputConfig ( HttpServletResponse aResponse ) throws Exception
{
   PrintEmailConfigImpl.load();

   PrintWriter out = aResponse.getWriter();
   aResponse.setContentType( "text/xml" );
   aResponse.setHeader( "Cache-Control", "no-cache" );

   out.println( "<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
   out.println( "<PrintEmailAction>" );
   out.println( "  <EmailAction>" );
   out.println( "    <Enable>"+PrintEmailConfigImpl.getEnableEmailAction()+"</Enable>" );
   out.println( "    <EmailMaxEmailAttachmentSize>"+PrintEmailConfigImpl.getEmailMaxEmailAttachmentSize()+"</EmailMaxEmailAttachmentSize>" );
   out.println( "  </EmailAction>" );
   out.println( "  <MobilePrint>" );
   out.println( "    <Enable>"+PrintEmailConfigImpl.getEnablePrintAction()+"</Enable>" );
   out.println( "    <MobilePrintServerEmailAddr>"+PrintEmailConfigImpl.getMobilePrintServerEmailAddr()+"</MobilePrintServerEmailAddr>" );
   out.println( "    <SupportedFileExtension>"+PrintEmailConfigImpl.getSupportedFileExtension()+"</SupportedFileExtension>" );
   out.println( "    <PrintMaxEmailAttachmentSize>"+PrintEmailConfigImpl.getPrintMaxEmailAttachmentSize()+"</PrintMaxEmailAttachmentSize>" );
   out.println( "  </MobilePrint>" );
   out.println( "</PrintEmailAction>" );
   out.close();
}

%>
<%@ include file="../jsp/common/start.jsp" %>
<%
	DSSession dssession = mDSSession;
	String handles = request.getParameter("document_handles");
	Boolean isEmail = false; // default to mobile print
        String toAddress = request.getParameter("to_address");
	if(toAddress != null)
	{
		isEmail = true;	
	}
	String requestType = request.getMethod();
	if (requestType.equals("GET"))
		outputConfig(response);
	else
	{
		//System.out.println("handles: "+handles+", toAddress: "+toAddress);
		StringTokenizer handleTokens = new StringTokenizer(handles, ",");
		int noOfTokens = handleTokens.countTokens();
		DSHandle dsHandles[] = new DSHandle[noOfTokens];

		for(int i = 0; i < noOfTokens; i++) {
			String docHdl = handleTokens.nextToken();

			if(docHdl != null && docHdl.length() > 0) {
				dsHandles[i] = new DSHandle(docHdl);
			}
		}

		if (isEmail)
		{
			boolean saveTO = false;
			boolean saveCC = false;
			boolean saveBCC = false;
			boolean ccMe = false;
			if (request.getParameter( "save_to" ) != null)
				if (request.getParameter( "save_to" ).toString().equals("yes"))
					saveTO = true;
			if (request.getParameter( "save_cc" ) != null)
				if (request.getParameter( "save_cc" ).toString().equals("yes"))
					saveCC = true;
			if (request.getParameter( "save_bcc" ) != null)
				if (request.getParameter( "save_bcc" ).toString().equals("yes"))
					saveBCC = true;
			if (request.getParameter( "cc_me" ) != null)
				if (request.getParameter( "cc_me" ).toString().equals("yes"))
					ccMe = true;

			EmailActionImpl emailAction = new EmailActionImpl();
			emailAction.doEmailAction(null, null, mDSSession, dsHandles, toAddress, request.getParameter( "cc_address" ), request.getParameter( "bcc_address" ), saveTO, saveCC, saveBCC, ccMe, request.getParameter( "emailSubject" ), request.getParameter( "body_field" ), request.getParameter( "choice" ), request.getRequestURL().toString(), request);

			int result = emailAction.getHTTPRetCode();
			if(result == 200)
				response.setStatus(HttpServletResponse.SC_OK);
			else{
				if(emailAction.getHTTPRetMessage() != null)
					response.sendError(result, emailAction.getHTTPRetMessage());
				else
					response.sendError(result);
			}
		}
		else
		{
			MobilePrintActionImpl printAction = new MobilePrintActionImpl();
			printAction.doMobilePrint(null, null, mDSSession, dsHandles);
			int result = printAction.getHTTPRetCode();
			if(result == 200)
				response.setStatus(HttpServletResponse.SC_OK);
			else{
				if(printAction.getHTTPRetMessage() != null)
					response.sendError(result, printAction.getHTTPRetMessage());
				else
					response.sendError(result);
			}
		}
		
	}
%>
<%@ include file="../jsp/common/end.jsp" %>