<%--
/**
 * AdminEmailConfiguration.jsp
 * JSP Page for Email Action Admin UI.
 */
--%>
<html>
<%@ page import="java.util.HashMap" %>
<%@ page import="com.xerox.docushare.amber.util.XSLTMessage" %>
<%@ page import="com.xerox.docushare.amber.validation.IntegerFieldValidator" %>
<%@ page import="com.xerox.docushare.amber.validation.BlankFieldValidator" %>
<%@ page import="com.xerox.docushare.impl.server.encodeUtility" %>
<%@ page import="com.xerox.docushare.printemail.constants.PrintEmailConstants" %>
<%@ page import="com.xerox.docushare.printemail.impl.PrintEmailConfigImpl" %>
<%@ page import="com.xerox.docushare.printemail.util.SMTPUtil" %>

<%@ include file="includes/sessionPageMethods.jsp" %>
<%@ include file="../jsp/common/start.jsp" %> 
<%@ include file="../jsp/common/adminbanner.jsp" %> 
<%@ include file="includes/includeL10N.jsp" %>

<%
String url="";
String sDisplayMsg= null;
Boolean bEnableEmailAction = true;
String sEnableEmailAction = "true";
String sEmailSMTPServer = null;
String sEmailSMTPServerPort = null;
String sEmailSMTPUsername = null;
String sEmailSMTPPassword = null;
String sEmailMaxEmailAttachmentSize = null;
String sInvalidEmailMsg = null;
String sInvalidSMTPServerMsg = null;
String sInvalidSMTPServerPortMsg = null;
String sInvalidMaxEmailAttachmentSizeMsg = null;
Boolean bWarningMessage = false;

try {
    if (dssession == null) {
        out.println(printEmailMessageObj.getMessageEscValue("printemail.dssession_null"));
        return;
    }

    response.setHeader("Cache-Control","no-cache");
    
    // Set to true if there is any invalid value entered
    Boolean bInvalidValFound = false;

    // Password encode utility
    encodeUtility encU = new encodeUtility() ;


    // If Test Connection button is clicked (AdminEmailTestConnection.jsp?sTestConnectionMs=...) and Reset 
    // button is not clicked, get values to display on UI from values stored in session attributes.
    if ((request.getParameter("sTestConnectionMsg") != null) && (request.getParameter("Reset") == null))  {
        sEnableEmailAction = (String)session.getAttribute("attrEnableEmailAction");
        if (sEnableEmailAction.equalsIgnoreCase("true")) {
        	bEnableEmailAction = true;
        } else {
        	bEnableEmailAction = false;
        }
        sEmailSMTPServer = (String)session.getAttribute("attrEmailSMTPServer");
        sEmailSMTPServerPort = (String)session.getAttribute("attrEmailSMTPServerPort");
        sEmailSMTPUsername = (String)session.getAttribute("attrEmailSMTPUsername");
        sEmailSMTPPassword = encU.decodeThis((String)session.getAttribute("attrEmailSMTPPassword"));
        sEmailMaxEmailAttachmentSize = (String)session.getAttribute("attrEmailMaxEmailAttachmentSize");
    } else {
        // Get the default values from Config file.
        PrintEmailConfigImpl.load();
        bEnableEmailAction = PrintEmailConfigImpl.getEnableEmailAction();
        sEmailSMTPServer = PrintEmailConfigImpl.getEmailSMTPHost();
        sEmailSMTPServerPort = PrintEmailConfigImpl.getEmailSMTPPort();
        sEmailSMTPUsername = PrintEmailConfigImpl.getEmailSMTPUserName();
        sEmailSMTPPassword = encU.decodeThis(PrintEmailConfigImpl.getEmailSMTPUserPassword());
        sEmailMaxEmailAttachmentSize = PrintEmailConfigImpl.getEmailMaxEmailAttachmentSize();
    }
    
    // When <Apply> Button button is clicked, settings are applied.
    if ((request.getParameter("Apply") != null) || (request.getParameter("TestConnection") != null)) {
        // Hashmap which is used to store key value pairs to be set in config file
    	HashMap hmProperty = new HashMap();
        
        // Get Enable Print Action
        sEnableEmailAction = request.getParameter("EnableEmailAction");
        if (sEnableEmailAction.equalsIgnoreCase("true")) {
        	bEnableEmailAction = true;
        } else {
        	bEnableEmailAction = false;
        }
        
        sEmailSMTPServer = request.getParameter("SMTPServer");
        BlankFieldValidator validateReqFeild = new BlankFieldValidator(currentLocale);
        if (bEnableEmailAction && !validateReqFeild.isValid("", sEmailSMTPServer)) {
            // Output error message if sEmailSMTPServer is empty
            sInvalidSMTPServerMsg= printEmailMessageObj.getMessageEscValue("printEmail.msg.requiresValue");
            bInvalidValFound = true;
        }
        sEmailSMTPUsername = request.getParameter("Username");

        sEmailSMTPPassword = request.getParameter("Password");
        
        // Get SMTPServerPort and check if it is an integer
        sEmailSMTPServerPort = request.getParameter("SMTPServerPort");
        IntegerFieldValidator validateInt = new IntegerFieldValidator();
        if (bEnableEmailAction && !validateInt.isValid("", sEmailSMTPServerPort)) {
            // Output error message if SMTPServerPort is not an integer
            String[] sArgs = {sEmailSMTPServerPort};
            sInvalidSMTPServerPortMsg= printEmailMessageObj.getMessageEscValue("printEmail.msg.invalidIntegerMsg", sArgs);
            
            bInvalidValFound = true;
        }
        
        // Get MaxEmailAttachmentSize and check if it is an integer
        sEmailMaxEmailAttachmentSize = request.getParameter("MaxEmailAttachmentSize");
        if (bEnableEmailAction && !validateInt.isValid("", sEmailMaxEmailAttachmentSize)) {
            // Output error message if MaxEmailAttachmentSize is not an integer
            String[] sArgs = {sEmailMaxEmailAttachmentSize};
            sInvalidMaxEmailAttachmentSizeMsg = printEmailMessageObj.getMessageEscValue("printEmail.msg.invalidIntegerMsg", sArgs);

            bInvalidValFound = true;
        }

        // When Apply button is clicked, save settings to config file.  
        if (!bInvalidValFound && (request.getParameter("Apply") != null)) {
            // Save key value pairs to config file
            hmProperty.put(PrintEmailConfigImpl.KEY_ENABLE_EMAIL_ACTION, sEnableEmailAction);
            hmProperty.put(PrintEmailConfigImpl.KEY_EMAIL_SMTP_HOST, sEmailSMTPServer);
            hmProperty.put(PrintEmailConfigImpl.KEY_EMAIL_SMTP_PORT, sEmailSMTPServerPort);
            hmProperty.put(PrintEmailConfigImpl.KEY_EMAIL_SMTP_USERNAME, sEmailSMTPUsername);
            
            // Encode password before saving it to config file
            hmProperty.put(PrintEmailConfigImpl.KEY_EMAIL_SMTP_USER_PASSWORD, encU.encodeThis(sEmailSMTPPassword));
            
            hmProperty.put(PrintEmailConfigImpl.KEY_EMAIL_MAX_EMAIL_ATTACHMENT_SIZE, sEmailMaxEmailAttachmentSize);
            Boolean bStatus = PrintEmailConfigImpl.setProperties(hmProperty);

            // Output Success msg after saving settings to config file.
            sDisplayMsg= printEmailMessageObj.getMessageEscValue("printEmail.msg.success");
        }
    }

    // When <Test Connection> button is clicked, call AdminEmailTestConnection.jsp which will 
    // send an email to login user(Administrator) if connection test is successful.
    if (request.getParameter("TestConnection") != null) {
        session.setAttribute("attrEnableEmailAction", sEnableEmailAction);
        session.setAttribute("attrEmailSMTPServer", sEmailSMTPServer);
        session.setAttribute("attrEmailSMTPServerPort", sEmailSMTPServerPort);
        session.setAttribute("attrEmailSMTPUsername", sEmailSMTPUsername);
        session.setAttribute("attrEmailSMTPPassword", encU.encodeThis(sEmailSMTPPassword));
        session.setAttribute("attrEmailMaxEmailAttachmentSize", sEmailMaxEmailAttachmentSize);
        String encodedUrl = "AdminEmailTestConnection.jsp";
        response.sendRedirect( encodedUrl ) ;
    }

    // Get the Test Connection message from AdminEmailTestConnection.jsp for display.
    // Do not use this Test Connection message if <Apply> or <Reset> button is pressed.
    if ((request.getParameter("sTestConnectionMsg") != null) && (request.getParameter("Apply") == null) && (request.getParameter("Reset") == null)) {
        sDisplayMsg = request.getParameter("sTestConnectionMsg");
        // if Test Connection Passed
        if (request.getParameter("sTestConnectionPass").equals("true")) {
            bWarningMessage = false;
        } else {
            bWarningMessage = true;
        }
    }

} catch(Exception e) {
	PrintEmailConstants.getLogger().error("AdminEmailConfiguration.jsp: Caught exception.", e);
	sDisplayMsg = printEmailMessageObj.getMessageEscValue("printEmail.msg.fail");
	bWarningMessage = true;
}
%>


<form name="EmailActionAdmin" method="post">

    <h2><%=printEmailMessageObj.getMessageEscValue("printEmail.emailAction")%></h2>
    <ul>
        <li><%=printEmailMessageObj.getMessageEscValue("printEmail.emailActionDetail")%></li>
    </ul>

<%if (bWarningMessage == true) {%>
    <font color=red><%=sDisplayMsg ==null?"":sDisplayMsg %></font>
<% } else { %>
    <%=sDisplayMsg ==null?"":sDisplayMsg %>
<% } %>

    <br></br>
    
    <table cellpadding="2" cellspacing="1" border="0">
        <tr>
            <th class="ColumnHeaderText"><%=printEmailMessageObj.getMessageEscValue("printEmail.name")%></th>
            <th class="ColumnHeaderText"><%=printEmailMessageObj.getMessageEscValue("printEmail.value")%></th>
            <td></td>
        </tr>

        <tr bgcolor="White">
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.enableEmailAction" + "&amp;key=" + "printEmail.help.enableEmailAction"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.enableEmailAction")%></a>
            </td>
            <td>
                <input value="true" Name="EnableEmailAction" tabindex="1" type="radio" <%=bEnableEmailAction?"checked":""%>/><%=printEmailMessageObj.getMessageEscValue("printEmail.yes")%>
                <input value="false" Name="EnableEmailAction" tabindex="1" type="radio" <%=bEnableEmailAction?"":"checked"%>/><%=printEmailMessageObj.getMessageEscValue("printEmail.no")%>
            </td>
        </tr>

        <tr bgcolor=<%=sInvalidSMTPServerMsg==null?"White":"Yellow"%>>
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.SMTPServer" + "&amp;key=" + "printEmail.help.emailSMTPServer"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.SMTPServer")%></a>
            </td>
            <td>
                <input size="50" value="<%=sEmailSMTPServer==null?"":sEmailSMTPServer%>" tabindex="2" name="SMTPServer" type="text"/>
            </td>
            <td><%=sInvalidSMTPServerMsg==null?"":sInvalidSMTPServerMsg%></td>
        </tr>

        <tr bgcolor=<%=sInvalidSMTPServerPortMsg==null?"White":"Yellow"%>>
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.SMTPServerPort" + "&amp;key=" + "printEmail.help.emailSMTPServerPort"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.SMTPServerPort")%></a>
            </td>
            <td>
                <input size="50" value="<%=sEmailSMTPServerPort==null?"":sEmailSMTPServerPort%>" tabindex="3" name="SMTPServerPort" type="text"/>
            </td>
            <td><%=sInvalidSMTPServerPortMsg==null?"":sInvalidSMTPServerPortMsg%></td>
        </tr>
        
        <tr bgcolor="White">
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.username" + "&amp;key=" + "printEmail.help.emailSMTPusername"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.username")%></a>
            </td>
            <td>
                <input size="50" value="<%=sEmailSMTPUsername==null?"":sEmailSMTPUsername%>" tabindex="4" name="Username" type="text"/>
            </td>
        </tr>
        
        <tr bgcolor="White">
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.password" + "&amp;key=" + "printEmail.help.emailSMTPpassword"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.password")%></a>
            </td>
            <td>
                <input size="50" tabindex="5" name="Password" type="password" value="<%=sEmailSMTPPassword%>"/>
                <input value="<%=sEmailSMTPPassword%>" type="hidden" name="_Password">
            </td>
        </tr>

        <tr bgcolor=<%=sInvalidMaxEmailAttachmentSizeMsg==null?"White":"Yellow"%>>
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.MaxEmailAttachmentSize" + "&amp;key=" + "printEmail.help.emailMaxEmailAttachmentSize"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.MaxEmailAttachmentSize")%></a>
            </td>
            <td>
                <input size="50" value="<%=sEmailMaxEmailAttachmentSize==null?"":sEmailMaxEmailAttachmentSize%>" tabindex="6" name="MaxEmailAttachmentSize" type="text"/>
            </td>
            <td><%=sInvalidMaxEmailAttachmentSizeMsg==null?"":sInvalidMaxEmailAttachmentSizeMsg%></td>
        </tr>
    </table>

    <br></br>
    
    <input value="<%=printEmailMessageObj.getMessageEscValue("printEmail.testConnection")%>" name="TestConnection" type="submit"/>
    <hr></hr>
    <input value="<%=printEmailMessageObj.getMessageEscValue("printEmail.reset")%>" name="Reset" type="submit"/>
    <input value="<%=printEmailMessageObj.getMessageEscValue("printEmail.apply")%>" name="Apply" type="submit"/>

</form>


<%@ include file="../jsp/common/adminfooter.jsp" %>
<%@ include file="../jsp/common/end.jsp" %>
</html>
