<%--
/**
 * AdminPrintConfiguration.jsp
 * JSP Page for Print Action Admin UI.
 */
--%>
<html>
<%@ page import="java.util.HashMap" %>
<%@ page import="com.xerox.docushare.amber.util.XSLTMessage" %>
<%@ page import="com.xerox.docushare.amber.validation.IntegerFieldValidator" %>
<%@ page import="com.xerox.docushare.amber.validation.BlankFieldValidator" %>
<%@ page import="com.xerox.docushare.amber.validation.EmailAddressFieldValidator" %>
<%@ page import="com.xerox.docushare.impl.server.encodeUtility" %>
<%@ page import="com.xerox.docushare.printemail.constants.PrintEmailConstants" %>
<%@ page import="com.xerox.docushare.printemail.impl.PrintEmailConfigImpl" %>
<%@ page import="com.xerox.docushare.printemail.util.SMTPUtil" %>

<%@ include file="includes/sessionPageMethods.jsp" %>
<%@ include file="../jsp/common/start.jsp" %> 
<%@ include file="../jsp/common/adminbanner.jsp" %> 
<%@ include file="includes/includeL10N.jsp" %>

<%
String url="";
String sDisplayMsg= null;
Boolean bEnablePrintAction = true;
String sMobilePrintServerEmailAddr = null;
String sEnablePrintAction = "true";
String sPrintSMTPServer = null;
String sPrintSMTPServerPort = null;
String sPrintSMTPUsername = null;
String sPrintSMTPPassword = null;
String sPrintMaxEmailAttachmentSize = null;
String sInvalidEmailMsg = null;
String sInvalidSMTPServerMsg = null;
String sInvalidSMTPServerPortMsg = null;
String sInvalidMaxEmailAttachmentSizeMsg = null;
Boolean bWarningMessage = false;

try {
    if (dssession == null) {
        out.println(printEmailMessageObj.getMessageEscValue("printemail.dssession_null"));
        return;
    }

    response.setHeader("Cache-Control","no-cache");
    
    // Set to true if there is any invalid value entered
    Boolean bInvalidValFound = false;

    // Password encode utility
    encodeUtility encU = new encodeUtility() ;


    // If Test Connection button is clicked (AdminPrintTestConnection.jsp?sTestConnectionMs=...) and Reset 
    // button is not clicked, get values to display on UI from values stored in session attributes.
    if ((request.getParameter("sTestConnectionMsg") != null) && (request.getParameter("Reset") == null))  {
        sEnablePrintAction = (String)session.getAttribute("attrEnablePrintAction");
        if (sEnablePrintAction.equalsIgnoreCase("true")) {
        	bEnablePrintAction = true;
        } else {
        	bEnablePrintAction = false;
        }
        sMobilePrintServerEmailAddr = (String)session.getAttribute("attrMobilePrintServerEmailAddr");
        sPrintSMTPServer = (String)session.getAttribute("attrPrintSMTPServer");
        sPrintSMTPServerPort = (String)session.getAttribute("attrPrintSMTPServerPort");
        sPrintSMTPUsername = (String)session.getAttribute("attrPrintSMTPUsername");
        sPrintSMTPPassword = encU.decodeThis((String)session.getAttribute("attrPrintSMTPPassword"));
        sPrintMaxEmailAttachmentSize = (String)session.getAttribute("attrPrintMaxEmailAttachmentSize");
    } else {
        // Get the default values from Config file.
        PrintEmailConfigImpl.load();
        bEnablePrintAction = PrintEmailConfigImpl.getEnablePrintAction();
        sMobilePrintServerEmailAddr = PrintEmailConfigImpl.getMobilePrintServerEmailAddr();
        sPrintSMTPServer = PrintEmailConfigImpl.getPrintSMTPHost();
        sPrintSMTPServerPort = PrintEmailConfigImpl.getPrintSMTPPort();
        sPrintSMTPUsername = PrintEmailConfigImpl.getPrintSMTPUserName();
        sPrintSMTPPassword = encU.decodeThis(PrintEmailConfigImpl.getPrintSMTPUserPassword());
        sPrintMaxEmailAttachmentSize = PrintEmailConfigImpl.getPrintMaxEmailAttachmentSize();
    }
    
    // When <Apply> Button button is clicked, settings are applied.
    if ((request.getParameter("Apply") != null) || (request.getParameter("TestConnection") != null)) {
        // Hashmap which is used to store key value pairs to be set in config file
    	HashMap hmProperty = new HashMap();
        
        // Get Enable Print Action
        sEnablePrintAction = request.getParameter("EnablePrintAction");
        if (sEnablePrintAction.equalsIgnoreCase("true")) {
        	bEnablePrintAction = true;
        } else {
        	bEnablePrintAction = false;
        }

        // Get Mobile Print Server Email Address and validate if it is of correct format
        sMobilePrintServerEmailAddr = request.getParameter("MobilePrintServerEmailAddr");
        EmailAddressFieldValidator validateEmail = new EmailAddressFieldValidator();
        if (bEnablePrintAction && !validateEmail.isValid("", sMobilePrintServerEmailAddr)) {
            // Output error message is email address is invalid
            sInvalidEmailMsg = printEmailMessageObj.getMessageEscValue("printEmail.msg.invalidEmail");
        	bInvalidValFound = true;
        }
        
        sPrintSMTPServer = request.getParameter("SMTPServer");
        BlankFieldValidator validateReqFeild = new BlankFieldValidator(currentLocale);
        if (bEnablePrintAction && !validateReqFeild.isValid("", sPrintSMTPServer)) {
            // Output error message if sPrintSMTPServer is empty
            sInvalidSMTPServerMsg= printEmailMessageObj.getMessageEscValue("printEmail.msg.requiresValue");
            bInvalidValFound = true;
        }
        sPrintSMTPUsername = request.getParameter("Username");

        sPrintSMTPPassword = request.getParameter("Password");
        
        // Get SMTPServerPort and check if it is an integer
        sPrintSMTPServerPort = request.getParameter("SMTPServerPort");
        IntegerFieldValidator validateInt = new IntegerFieldValidator();
        if (bEnablePrintAction && !validateInt.isValid("", sPrintSMTPServerPort)) {
            // Output error message if SMTPServerPort is not an integer
            String[] sArgs = {sPrintSMTPServerPort};
            sInvalidSMTPServerPortMsg= printEmailMessageObj.getMessageEscValue("printEmail.msg.invalidIntegerMsg", sArgs);
            
            bInvalidValFound = true;
        }
        
        // Get MaxEmailAttachmentSize and check if it is an integer
        sPrintMaxEmailAttachmentSize = request.getParameter("MaxEmailAttachmentSize");
        if (bEnablePrintAction && !validateInt.isValid("", sPrintMaxEmailAttachmentSize)) {
            // Output error message if MaxEmailAttachmentSize is not an integer
            String[] sArgs = {sPrintMaxEmailAttachmentSize};
            sInvalidMaxEmailAttachmentSizeMsg = printEmailMessageObj.getMessageEscValue("printEmail.msg.invalidIntegerMsg", sArgs);

            bInvalidValFound = true;
        }

        // When Apply button is clicked, save settings to config file.  
        if (!bInvalidValFound && (request.getParameter("Apply") != null)) {
            // Save key value pairs to config file
            hmProperty.put(PrintEmailConfigImpl.KEY_ENABLE_PRINT_ACTION, sEnablePrintAction);
            hmProperty.put(PrintEmailConfigImpl.KEY_MOBILE_PRINT_SERVER_EMAIL_ADDR, sMobilePrintServerEmailAddr);
            hmProperty.put(PrintEmailConfigImpl.KEY_PRINT_SMTP_HOST, sPrintSMTPServer);
            hmProperty.put(PrintEmailConfigImpl.KEY_PRINT_SMTP_PORT, sPrintSMTPServerPort);
            hmProperty.put(PrintEmailConfigImpl.KEY_PRINT_SMTP_USERNAME, sPrintSMTPUsername);
            
            // Encode password before saving it to config file
            hmProperty.put(PrintEmailConfigImpl.KEY_PRINT_SMTP_USER_PASSWORD, encU.encodeThis(sPrintSMTPPassword));

            hmProperty.put(PrintEmailConfigImpl.KEY_PRINT_MAX_EMAIL_ATTACHMENT_SIZE, sPrintMaxEmailAttachmentSize);
            Boolean bStatus = PrintEmailConfigImpl.setProperties(hmProperty);

            // Output Success msg after saving settings to config file.
            sDisplayMsg= printEmailMessageObj.getMessageEscValue("printEmail.msg.success");
        }
    }

    // When <Test Connection> button is clicked, call AdminPrintTestConnection.jsp which will 
    // send an email to login user(Administrator) if connection test is successful.
    if (request.getParameter("TestConnection") != null) {
        session.setAttribute("attrEnablePrintAction", sEnablePrintAction);
        session.setAttribute("attrMobilePrintServerEmailAddr", sMobilePrintServerEmailAddr);
        session.setAttribute("attrPrintSMTPServer", sPrintSMTPServer);
        session.setAttribute("attrPrintSMTPServerPort", sPrintSMTPServerPort);
        session.setAttribute("attrPrintSMTPUsername", sPrintSMTPUsername);
        session.setAttribute("attrPrintSMTPPassword", encU.encodeThis(sPrintSMTPPassword));
        session.setAttribute("attrPrintMaxEmailAttachmentSize", sPrintMaxEmailAttachmentSize);
        String encodedUrl = "AdminPrintTestConnection.jsp";
        response.sendRedirect( encodedUrl ) ;
    }

    // Get the Test Connection message from AdminPrintTestConnection.jsp for display.
    // Do not use this Test Connection message if <Apply> or <Reset> button is pressed.
    if ((request.getParameter("sTestConnectionMsg") != null) && (request.getParameter("Apply") == null) && (request.getParameter("Reset") == null)) {
        sDisplayMsg = request.getParameter("sTestConnectionMsg");
        // if Test Connection Passed
        if (request.getParameter("sTestConnectionPass").equals("true")) {
            bWarningMessage = false;
        } else {
            bWarningMessage = true;
        }
    }

} catch(Exception e) {
	PrintEmailConstants.getLogger().error("AdminPrintConfiguration.jsp: Caught exception.", e);
	sDisplayMsg = printEmailMessageObj.getMessageEscValue("printEmail.msg.fail");
	bWarningMessage = true;
}
%>


<form name="PrintActionAdmin" method="post">

    <h2><%=printEmailMessageObj.getMessageEscValue("printEmail.printAction")%></h2>
    <ul>
        <li><%=printEmailMessageObj.getMessageEscValue("printEmail.printActionDetail1")%></li>
        <li><%=printEmailMessageObj.getMessageEscValue("printEmail.printActionDetail2")%>&nbsp<%=PrintEmailConfigImpl.getSupportedFileExtension()%></li>
    </ul>

<%if (bWarningMessage == true) {%>
    <font color=red><%=sDisplayMsg ==null?"":sDisplayMsg %></font>
<% } else { %>
    <%=sDisplayMsg ==null?"":sDisplayMsg %>
<% } %>

    <br></br>
    
    <table cellpadding="2" cellspacing="1" border="0">
        <tr>
            <th class="ColumnHeaderText"><%=printEmailMessageObj.getMessageEscValue("printEmail.name")%></th>
            <th class="ColumnHeaderText"><%=printEmailMessageObj.getMessageEscValue("printEmail.value")%></th>
            <td></td>
        </tr>

        <tr bgcolor="White">
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.enablePrintAction" + "&amp;key=" + "printEmail.help.enablePrintAction"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.enablePrintAction")%></a>
            </td>
            <td>
                <input value="true" Name="EnablePrintAction" tabindex="1" type="radio" <%=bEnablePrintAction?"checked":""%>/><%=printEmailMessageObj.getMessageEscValue("printEmail.yes")%>
                <input value="false" Name="EnablePrintAction" tabindex="1" type="radio" <%=bEnablePrintAction?"":"checked"%>/><%=printEmailMessageObj.getMessageEscValue("printEmail.no")%>
            </td>
        </tr>

        <tr bgcolor=<%=sInvalidEmailMsg==null?"White":"Yellow"%>>
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.mobilePrintServerEmailAddr" + "&amp;key=" + "printEmail.help.mobilePrintServerEmailAddr"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.mobilePrintServerEmailAddr")%></a>
            </td>
            <td>
                <input size="50" value="<%=sMobilePrintServerEmailAddr==null?"":sMobilePrintServerEmailAddr%>" tabindex="2" name="MobilePrintServerEmailAddr" type="text"/>
            </td>
            <td><%=sInvalidEmailMsg==null?"":sInvalidEmailMsg%></td>
        </tr>

        <tr><td>&nbsp</td><td>&nbsp</td><td>&nbsp</td></tr>

        <tr>
            <td colspan="2">
                <b><%=printEmailMessageObj.getMessageEscValue("printEmail.SMTPServerSetting")%></b>&nbsp<%=printEmailMessageObj.getMessageEscValue("printEmail.SMTPServerSettingDetail")%>
            </td>
        </tr>
        <tr>

        <tr bgcolor=<%=sInvalidSMTPServerMsg==null?"White":"Yellow"%>>
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.SMTPServer" + "&amp;key=" + "printEmail.help.printSMTPServer"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.SMTPServer")%></a>
            </td>
            <td>
                <input size="50" value="<%=sPrintSMTPServer==null?"":sPrintSMTPServer%>" tabindex="2" name="SMTPServer" type="text"/>
            </td>
            <td><%=sInvalidSMTPServerMsg==null?"":sInvalidSMTPServerMsg%></td>
        </tr>

        <tr bgcolor=<%=sInvalidSMTPServerPortMsg==null?"White":"Yellow"%>>
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.SMTPServerPort" + "&amp;key=" + "printEmail.help.printSMTPServerPort"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.SMTPServerPort")%></a>
            </td>
            <td>
                <input size="50" value="<%=sPrintSMTPServerPort==null?"":sPrintSMTPServerPort%>" tabindex="3" name="SMTPServerPort" type="text"/>
            </td>
            <td><%=sInvalidSMTPServerPortMsg==null?"":sInvalidSMTPServerPortMsg%></td>
        </tr>
        
        <tr bgcolor="White">
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.username" + "&amp;key=" + "printEmail.help.printSMTPusername"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.username")%></a>
            </td>
            <td>
                <input size="50" value="<%=sPrintSMTPUsername==null?"":sPrintSMTPUsername%>" tabindex="4" name="Username" type="text"/>
            </td>
        </tr>
        
        <tr bgcolor="White">
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.password" + "&amp;key=" + "printEmail.help.printSMTPpassword"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.password")%></a>
            </td>
            <td>
                <input size="50" tabindex="5" name="Password" type="password" value="<%=sPrintSMTPPassword%>"/>
                <input value="<%=sPrintSMTPPassword%>" type="hidden" name="_Password">
            </td>
        </tr>

        <tr bgcolor=<%=sInvalidMaxEmailAttachmentSizeMsg==null?"White":"Yellow"%>>
            <td>
                <% url = XSLTMessage.getDocumentBase() + "printemail/help/thirdPartyHelpTextPage.jsp?resourceBundle="+ resourceBundle + "&amp;name=" + "printEmail.MaxEmailAttachmentSize" + "&amp;key=" + "printEmail.help.printMaxEmailAttachmentSize"; %>
                <a href="javascript:openHelpTextWindow('<%=url%>');"><%=printEmailMessageObj.getMessageEscValue("printEmail.MaxEmailAttachmentSize")%></a>
            </td>
            <td>
                <input size="50" value="<%=sPrintMaxEmailAttachmentSize==null?"":sPrintMaxEmailAttachmentSize%>" tabindex="6" name="MaxEmailAttachmentSize" type="text"/>
            </td>
            <td><%=sInvalidMaxEmailAttachmentSizeMsg==null?"":sInvalidMaxEmailAttachmentSizeMsg%></td>
        </tr>
    </table>

    <br></br>
    
    <input value="<%=printEmailMessageObj.getMessageEscValue("printEmail.testConnection")%>" name="TestConnection" type="submit"/>
    <hr></hr>
    <input value="<%=printEmailMessageObj.getMessageEscValue("printEmail.reset")%>" name="Reset" type="submit"/>
    <input value="<%=printEmailMessageObj.getMessageEscValue("printEmail.apply")%>" name="Apply" type="submit"/>

</form>


<%@ include file="../jsp/common/adminfooter.jsp" %>
<%@ include file="../jsp/common/end.jsp" %>
</html>
